=== debian/changelog ===
riseup-vpn (0.24.10+ds1-1) unstable; urgency=medium

  [ Maytham Alsudany ]
  * Add -trimpath to ensure reproducible builds

  [ Nilesh Patra ]
  * New upstream version 0.24.10+ds1
  * Remove un-needed vendor code, add ginkgo as B-D
  * Re-diff patch

 -- Nilesh Patra <nilesh@debian.org>  Tue, 04 Feb 2025 23:45:46 +0530
