## riseup-vpn 0.25.8%2Bds3

=== debian/changelog ===
riseup-vpn (0.25.8+ds3-3build1) resolute; urgency=medium

  * No-change rebuild for Qt 6.10.2.

 -- Rik Mills <rikmills@kde.org>  Sun, 22 Feb 2026 11:29:02 +0000

riseup-vpn (0.25.8+ds3-3) unstable; urgency=medium

  * Better patch for fixing Motd which does not lead to qml warnings on launch
  * Revert "Disable tests on riscv64 due to bug in go compiler" -- this is fixed
    in golang 1.24.4-4 upload (See #1114841)
  * Add patch to fixup couple of QML warnings after launching the app
  * Remove Redundant "Rules-Requires-Root: no"

 -- Nilesh Patra <nilesh@debian.org>  Sat, 18 Oct 2025 16:33:58 +0530

riseup-vpn (0.25.8+ds3-2) unstable; urgency=medium

  * Add patch to workaround progressbar not displaying with QT6.9 update
    + The work-around for progressbar and MOTD shall need to stay until
      #1118281 is fixed.
  * Add Depends on more polkits than gnome-polkit which has been removed.

 -- Nilesh Patra <nilesh@debian.org>  Sat, 18 Oct 2025 00:19:54 +0530

riseup-vpn (0.25.8+ds3-1) unstable; urgency=medium

  * Add B-D on golang-refraction-networking-utls-dev
  * Embed copy of snowflake common dir back in the package
    + snowflake package version 2.10.1 no longer vendors all the
      required files to build riseup-vpn.
  * Add patch to fix motd window with QT6.9

 -- Nilesh Patra <nilesh@debian.org>  Tue, 07 Oct 2025 23:55:39 +0530

riseup-vpn (0.25.8+ds2-2) unstable; urgency=medium

  * Add Headers to patches
  * Tweak createmanpages script and update manpages
  * Move bitmask-root manpage from section 1 to section 8
    as this is not supposed to be run manually
  * Update d/watch to version 5
  * d/salsa-ci.yml: Add provision to build also on riscv64
  * Disable tests on riscv64 due to bug in go compiler when
    packages are built with CGO_ENABLED=1

 -- Nilesh Patra <nilesh@debian.org>  Fri, 12 Sep 2025 02:03:12 +0530

riseup-vpn (0.25.8+ds2-1) unstable; urgency=medium

  * New upstream version 0.25.8+ds2 (Closes: #1097793)
  * New patch to add in missing defines in test.pro to
    fix compilation
  * Temporarily vendor quic-go until dependency bump is
    fixed upstream
    + Issue forwarded upstream with a patch
  * d/control:
    + Bump Standards-Version to 4.7.2 (no changes needed)
    + Switch to Static-Built-Using
  * d/copyright:
    + Update copyright years
    + Mention new vendored deps to d/copyright
  * Add patch to not check for updates
  * Add patch to use SOURCE_DATE_EPOCH (fixes reprotest)
  * Add patch to potentially fixup binding loop
  * Add qml6-module-qtcore to Depends (Closes: #1110558)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 11 Sep 2025 02:33:40 +0530
