=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: riseup-vpn
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Nilesh Patra <nilesh@debian.org>
 Section: net
 Testsuite: autopkgtest-pkg-go
@@ -7,7 +8,6 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any (>= 2:1.20~),
-               golang-github-lucas-clemente-quic-go-dev (>= 0.46.0-2~),
                golang-github-coreos-bbolt-dev,
                golang-github-cretz-bine-dev,
                golang-github-go-openapi-errors-dev,
@@ -28,6 +28,7 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
+               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -44,7 +45,6 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
-               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -54,11 +54,10 @@
                qt6-svg-dev,
                qt6-tools-dev,
                qt6-tools-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/riseup-vpn
 Vcs-Git: https://salsa.debian.org/go-team/packages/riseup-vpn.git
 Homepage: https://0xacab.org/leap/bitmask-vpn
-Rules-Requires-Root: no
 XS-Go-Import-Path: 0xacab.org/leap/bitmask-vpn
 
 Package: riseup-vpn
@@ -69,9 +68,10 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         policykit-1-gnome | polkit-1-auth-agent,
+         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
+         qml6-module-qtcore,
          qml6-module-qt-labs-platform,
          qml6-module-qt-labs-settings,
          qml6-module-qtquick-effects,
@@ -84,7 +84,7 @@
          qml6-module-qtquick-window,
          ${misc:Depends},
          ${shlibs:Depends}
-Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Recommends: qt6-wayland
 Description: Easy, fast, and secure VPN service from riseup.net
  Riseup offers Personal VPN service for censorship circumvention,
