=== debian/changelog ===
riseup-vpn (0.25.8+ds2-2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Nilesh Patra <nilesh@debian.org>  Mon, 15 Sep 2025 03:39:41 +0530
