=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: riseup-vpn
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Nilesh Patra <nilesh@debian.org>
 Section: net
 Testsuite: autopkgtest-pkg-go
@@ -28,7 +27,6 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
-               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -45,6 +43,7 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
+               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -58,6 +57,7 @@
 Vcs-Browser: https://salsa.debian.org/go-team/packages/riseup-vpn
 Vcs-Git: https://salsa.debian.org/go-team/packages/riseup-vpn.git
 Homepage: https://0xacab.org/leap/bitmask-vpn
+Rules-Requires-Root: no
 XS-Go-Import-Path: 0xacab.org/leap/bitmask-vpn
 
 Package: riseup-vpn
@@ -68,7 +68,7 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
+         policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
          qml6-module-qtcore,
