=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	cd $(BUILDDIR) && $(MAKE) gen_providers_json PROVIDER=riseup,riseupbeta && $(MAKE) build VERSION=$(VERSION) LRELEASE=/usr/lib/qt6/bin/lrelease QMAKE=/usr/bin/qmake6 PROVIDER=riseup TARGET=riseup-vpn
 
 override_dh_auto_test:
+ifneq (riscv64,$(DEB_HOST_ARCH))
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Qmake test
 	cd $(BUILDDIR) && qmake6 test.pro -o tests/Makefile.test && \
@@ -30,6 +31,7 @@
 	# Golang test
 	DH_GOLANG_EXCLUDES=gui dh_auto_test
 endif
+endif
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source
