=== debian/control ===
--- 
+++ 
@@ -27,6 +27,7 @@
                golang-github-pkg-errors-dev,
                golang-github-prometheus-community-pro-bing-dev,
                golang-github-protonmail-go-autostart-dev,
+               golang-refraction-networking-utls-dev,
                golang-github-rakyll-statik-dev,
                golang-github-rs-zerolog-dev (>= 1.29.1-1~),
                golang-github-sevlyar-go-daemon-dev,
@@ -43,7 +44,6 @@
                golang-golang-x-tools-dev,
                golang-golang-x-xerrors-dev,
                golang-goptlib-dev,
-               golang-snowflake-dev,
                libqt6quickcontrols2-6,
                qmake6,
                qt6-base-dev,
@@ -68,7 +68,7 @@
          libqt6svg6,
          openvpn,
          pkexec,
-         policykit-1-gnome | polkit-1-auth-agent,
+         lxpolkit | lxqt-policykit | mate-polkit | polkit-kde-agent-1 | policykit-1-gnome | polkit-1-auth-agent,
          procps,
          python3:any,
          qml6-module-qtcore,
