=== debian/watch ===
Version: 5

Template: Gitlab
Dist: https://0xacab.org/leap/bitmask-vpn
Repack: yes
Compression: xz
Repacksuffix: +ds1
Dversion-Mangle: auto
